<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for documentResult StructType
 * Meta information extracted from the WSDL
 * - type: tns:documentResult
 * @subpackage Structs
 */
class DocumentResult extends AbstractStructBase
{
    /**
     * The typeDocument
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $typeDocument;
    /**
     * The idDocument
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $idDocument;
    /**
     * The status
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $status;
    /**
     * The statusDocument
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $statusDocument;
    /**
     * The statusSunat
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $statusSunat;
    /**
     * The signTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signTime;
    /**
     * The declareTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $declareTime;
    /**
     * The responseTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $responseTime;
    /**
     * The signatureValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $signatureValue;
    /**
     * The emisionTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $emisionTime;
    /**
     * The message
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $message;
    /**
     * The messageSunat
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $messageSunat;
    /**
     * The messages
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Message[]
     */
    public $messages;
    /**
     * The hashCode
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $hashCode;
    /**
     * The barCodeFileUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $barCodeFileUrl;
    /**
     * The pdfFileUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $pdfFileUrl;
    /**
     * The xmlFileSignUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $xmlFileSignUrl;
    /**
     * The xmlFileSunatUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $xmlFileSunatUrl;
    /**
     * The tipoDocumentoEmisor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tipoDocumentoEmisor;
    /**
     * The numeroDocumentoEmisor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numeroDocumentoEmisor;
    /**
     * The tipoDocumentoAdquiriente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tipoDocumentoAdquiriente;
    /**
     * The numeroDocumentoAdquiriente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numeroDocumentoAdquiriente;
    /**
     * The razonSocialAdquiriente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $razonSocialAdquiriente;
    /**
     * The razonSocialEmisor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $razonSocialEmisor;
    /**
     * The adicionales
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Adicionales
     */
    public $adicionales;
    /**
     * The item
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Item1[]
     */
    public $item;
    /**
     * Constructor method for documentResult
     * @uses DocumentResult::setTypeDocument()
     * @uses DocumentResult::setIdDocument()
     * @uses DocumentResult::setStatus()
     * @uses DocumentResult::setStatusDocument()
     * @uses DocumentResult::setStatusSunat()
     * @uses DocumentResult::setSignTime()
     * @uses DocumentResult::setDeclareTime()
     * @uses DocumentResult::setResponseTime()
     * @uses DocumentResult::setSignatureValue()
     * @uses DocumentResult::setEmisionTime()
     * @uses DocumentResult::setMessage()
     * @uses DocumentResult::setMessageSunat()
     * @uses DocumentResult::setMessages()
     * @uses DocumentResult::setHashCode()
     * @uses DocumentResult::setBarCodeFileUrl()
     * @uses DocumentResult::setPdfFileUrl()
     * @uses DocumentResult::setXmlFileSignUrl()
     * @uses DocumentResult::setXmlFileSunatUrl()
     * @uses DocumentResult::setTipoDocumentoEmisor()
     * @uses DocumentResult::setNumeroDocumentoEmisor()
     * @uses DocumentResult::setTipoDocumentoAdquiriente()
     * @uses DocumentResult::setNumeroDocumentoAdquiriente()
     * @uses DocumentResult::setRazonSocialAdquiriente()
     * @uses DocumentResult::setRazonSocialEmisor()
     * @uses DocumentResult::setAdicionales()
     * @uses DocumentResult::setItem()
     * @param string $typeDocument
     * @param string $idDocument
     * @param string $status
     * @param string $statusDocument
     * @param string $statusSunat
     * @param string $signTime
     * @param string $declareTime
     * @param string $responseTime
     * @param string $signatureValue
     * @param string $emisionTime
     * @param string $message
     * @param string $messageSunat
     * @param \StructType\Message[] $messages
     * @param string $hashCode
     * @param string $barCodeFileUrl
     * @param string $pdfFileUrl
     * @param string $xmlFileSignUrl
     * @param string $xmlFileSunatUrl
     * @param string $tipoDocumentoEmisor
     * @param string $numeroDocumentoEmisor
     * @param string $tipoDocumentoAdquiriente
     * @param string $numeroDocumentoAdquiriente
     * @param string $razonSocialAdquiriente
     * @param string $razonSocialEmisor
     * @param \StructType\Adicionales $adicionales
     * @param \StructType\Item1[] $item
     */
    public function __construct($typeDocument = null, $idDocument = null, $status = null, $statusDocument = null, $statusSunat = null, $signTime = null, $declareTime = null, $responseTime = null, $signatureValue = null, $emisionTime = null, $message = null, $messageSunat = null, array $messages = array(), $hashCode = null, $barCodeFileUrl = null, $pdfFileUrl = null, $xmlFileSignUrl = null, $xmlFileSunatUrl = null, $tipoDocumentoEmisor = null, $numeroDocumentoEmisor = null, $tipoDocumentoAdquiriente = null, $numeroDocumentoAdquiriente = null, $razonSocialAdquiriente = null, $razonSocialEmisor = null, \StructType\Adicionales $adicionales = null, array $item = array())
    {
        $this
            ->setTypeDocument($typeDocument)
            ->setIdDocument($idDocument)
            ->setStatus($status)
            ->setStatusDocument($statusDocument)
            ->setStatusSunat($statusSunat)
            ->setSignTime($signTime)
            ->setDeclareTime($declareTime)
            ->setResponseTime($responseTime)
            ->setSignatureValue($signatureValue)
            ->setEmisionTime($emisionTime)
            ->setMessage($message)
            ->setMessageSunat($messageSunat)
            ->setMessages($messages)
            ->setHashCode($hashCode)
            ->setBarCodeFileUrl($barCodeFileUrl)
            ->setPdfFileUrl($pdfFileUrl)
            ->setXmlFileSignUrl($xmlFileSignUrl)
            ->setXmlFileSunatUrl($xmlFileSunatUrl)
            ->setTipoDocumentoEmisor($tipoDocumentoEmisor)
            ->setNumeroDocumentoEmisor($numeroDocumentoEmisor)
            ->setTipoDocumentoAdquiriente($tipoDocumentoAdquiriente)
            ->setNumeroDocumentoAdquiriente($numeroDocumentoAdquiriente)
            ->setRazonSocialAdquiriente($razonSocialAdquiriente)
            ->setRazonSocialEmisor($razonSocialEmisor)
            ->setAdicionales($adicionales)
            ->setItem($item);
    }
    /**
     * Get typeDocument value
     * @return string|null
     */
    public function getTypeDocument()
    {
        return $this->typeDocument;
    }
    /**
     * Set typeDocument value
     * @param string $typeDocument
     * @return \StructType\DocumentResult
     */
    public function setTypeDocument($typeDocument = null)
    {
        // validation for constraint: string
        if (!is_null($typeDocument) && !is_string($typeDocument)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typeDocument, true), gettype($typeDocument)), __LINE__);
        }
        $this->typeDocument = $typeDocument;
        return $this;
    }
    /**
     * Get idDocument value
     * @return string|null
     */
    public function getIdDocument()
    {
        return $this->idDocument;
    }
    /**
     * Set idDocument value
     * @param string $idDocument
     * @return \StructType\DocumentResult
     */
    public function setIdDocument($idDocument = null)
    {
        // validation for constraint: string
        if (!is_null($idDocument) && !is_string($idDocument)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idDocument, true), gettype($idDocument)), __LINE__);
        }
        $this->idDocument = $idDocument;
        return $this;
    }
    /**
     * Get status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->status;
    }
    /**
     * Set status value
     * @param string $status
     * @return \StructType\DocumentResult
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->status = $status;
        return $this;
    }
    /**
     * Get statusDocument value
     * @return string|null
     */
    public function getStatusDocument()
    {
        return $this->statusDocument;
    }
    /**
     * Set statusDocument value
     * @param string $statusDocument
     * @return \StructType\DocumentResult
     */
    public function setStatusDocument($statusDocument = null)
    {
        // validation for constraint: string
        if (!is_null($statusDocument) && !is_string($statusDocument)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusDocument, true), gettype($statusDocument)), __LINE__);
        }
        $this->statusDocument = $statusDocument;
        return $this;
    }
    /**
     * Get statusSunat value
     * @return string|null
     */
    public function getStatusSunat()
    {
        return $this->statusSunat;
    }
    /**
     * Set statusSunat value
     * @param string $statusSunat
     * @return \StructType\DocumentResult
     */
    public function setStatusSunat($statusSunat = null)
    {
        // validation for constraint: string
        if (!is_null($statusSunat) && !is_string($statusSunat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusSunat, true), gettype($statusSunat)), __LINE__);
        }
        $this->statusSunat = $statusSunat;
        return $this;
    }
    /**
     * Get signTime value
     * @return string|null
     */
    public function getSignTime()
    {
        return $this->signTime;
    }
    /**
     * Set signTime value
     * @param string $signTime
     * @return \StructType\DocumentResult
     */
    public function setSignTime($signTime = null)
    {
        // validation for constraint: string
        if (!is_null($signTime) && !is_string($signTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signTime, true), gettype($signTime)), __LINE__);
        }
        $this->signTime = $signTime;
        return $this;
    }
    /**
     * Get declareTime value
     * @return string|null
     */
    public function getDeclareTime()
    {
        return $this->declareTime;
    }
    /**
     * Set declareTime value
     * @param string $declareTime
     * @return \StructType\DocumentResult
     */
    public function setDeclareTime($declareTime = null)
    {
        // validation for constraint: string
        if (!is_null($declareTime) && !is_string($declareTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($declareTime, true), gettype($declareTime)), __LINE__);
        }
        $this->declareTime = $declareTime;
        return $this;
    }
    /**
     * Get responseTime value
     * @return string|null
     */
    public function getResponseTime()
    {
        return $this->responseTime;
    }
    /**
     * Set responseTime value
     * @param string $responseTime
     * @return \StructType\DocumentResult
     */
    public function setResponseTime($responseTime = null)
    {
        // validation for constraint: string
        if (!is_null($responseTime) && !is_string($responseTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($responseTime, true), gettype($responseTime)), __LINE__);
        }
        $this->responseTime = $responseTime;
        return $this;
    }
    /**
     * Get signatureValue value
     * @return string|null
     */
    public function getSignatureValue()
    {
        return $this->signatureValue;
    }
    /**
     * Set signatureValue value
     * @param string $signatureValue
     * @return \StructType\DocumentResult
     */
    public function setSignatureValue($signatureValue = null)
    {
        // validation for constraint: string
        if (!is_null($signatureValue) && !is_string($signatureValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($signatureValue, true), gettype($signatureValue)), __LINE__);
        }
        $this->signatureValue = $signatureValue;
        return $this;
    }
    /**
     * Get emisionTime value
     * @return string|null
     */
    public function getEmisionTime()
    {
        return $this->emisionTime;
    }
    /**
     * Set emisionTime value
     * @param string $emisionTime
     * @return \StructType\DocumentResult
     */
    public function setEmisionTime($emisionTime = null)
    {
        // validation for constraint: string
        if (!is_null($emisionTime) && !is_string($emisionTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($emisionTime, true), gettype($emisionTime)), __LINE__);
        }
        $this->emisionTime = $emisionTime;
        return $this;
    }
    /**
     * Get message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->message;
    }
    /**
     * Set message value
     * @param string $message
     * @return \StructType\DocumentResult
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($message, true), gettype($message)), __LINE__);
        }
        $this->message = $message;
        return $this;
    }
    /**
     * Get messageSunat value
     * @return string|null
     */
    public function getMessageSunat()
    {
        return $this->messageSunat;
    }
    /**
     * Set messageSunat value
     * @param string $messageSunat
     * @return \StructType\DocumentResult
     */
    public function setMessageSunat($messageSunat = null)
    {
        // validation for constraint: string
        if (!is_null($messageSunat) && !is_string($messageSunat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($messageSunat, true), gettype($messageSunat)), __LINE__);
        }
        $this->messageSunat = $messageSunat;
        return $this;
    }
    /**
     * Get messages value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Message[]|null
     */
    public function getMessages()
    {
        return isset($this->messages) ? $this->messages : null;
    }
    /**
     * This method is responsible for validating the values passed to the setMessages method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMessages method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMessagesForArrayConstraintsFromSetMessages(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $documentResultMessagesItem) {
            // validation for constraint: itemType
            if (!$documentResultMessagesItem instanceof \StructType\Message) {
                $invalidValues[] = is_object($documentResultMessagesItem) ? get_class($documentResultMessagesItem) : sprintf('%s(%s)', gettype($documentResultMessagesItem), var_export($documentResultMessagesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The messages property can only contain items of type \StructType\Message, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set messages value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Message[] $messages
     * @return \StructType\DocumentResult
     */
    public function setMessages(array $messages = array())
    {
        // validation for constraint: array
        if ('' !== ($messagesArrayErrorMessage = self::validateMessagesForArrayConstraintsFromSetMessages($messages))) {
            throw new \InvalidArgumentException($messagesArrayErrorMessage, __LINE__);
        }
        if (is_null($messages) || (is_array($messages) && empty($messages))) {
            unset($this->messages);
        } else {
            $this->messages = $messages;
        }
        return $this;
    }
    /**
     * Add item to messages value
     * @throws \InvalidArgumentException
     * @param \StructType\Message $item
     * @return \StructType\DocumentResult
     */
    public function addToMessages(\StructType\Message $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Message) {
            throw new \InvalidArgumentException(sprintf('The messages property can only contain items of type \StructType\Message, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->messages[] = $item;
        return $this;
    }
    /**
     * Get hashCode value
     * @return string|null
     */
    public function getHashCode()
    {
        return $this->hashCode;
    }
    /**
     * Set hashCode value
     * @param string $hashCode
     * @return \StructType\DocumentResult
     */
    public function setHashCode($hashCode = null)
    {
        // validation for constraint: string
        if (!is_null($hashCode) && !is_string($hashCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($hashCode, true), gettype($hashCode)), __LINE__);
        }
        $this->hashCode = $hashCode;
        return $this;
    }
    /**
     * Get barCodeFileUrl value
     * @return string|null
     */
    public function getBarCodeFileUrl()
    {
        return $this->barCodeFileUrl;
    }
    /**
     * Set barCodeFileUrl value
     * @param string $barCodeFileUrl
     * @return \StructType\DocumentResult
     */
    public function setBarCodeFileUrl($barCodeFileUrl = null)
    {
        // validation for constraint: string
        if (!is_null($barCodeFileUrl) && !is_string($barCodeFileUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($barCodeFileUrl, true), gettype($barCodeFileUrl)), __LINE__);
        }
        $this->barCodeFileUrl = $barCodeFileUrl;
        return $this;
    }
    /**
     * Get pdfFileUrl value
     * @return string|null
     */
    public function getPdfFileUrl()
    {
        return $this->pdfFileUrl;
    }
    /**
     * Set pdfFileUrl value
     * @param string $pdfFileUrl
     * @return \StructType\DocumentResult
     */
    public function setPdfFileUrl($pdfFileUrl = null)
    {
        // validation for constraint: string
        if (!is_null($pdfFileUrl) && !is_string($pdfFileUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($pdfFileUrl, true), gettype($pdfFileUrl)), __LINE__);
        }
        $this->pdfFileUrl = $pdfFileUrl;
        return $this;
    }
    /**
     * Get xmlFileSignUrl value
     * @return string|null
     */
    public function getXmlFileSignUrl()
    {
        return $this->xmlFileSignUrl;
    }
    /**
     * Set xmlFileSignUrl value
     * @param string $xmlFileSignUrl
     * @return \StructType\DocumentResult
     */
    public function setXmlFileSignUrl($xmlFileSignUrl = null)
    {
        // validation for constraint: string
        if (!is_null($xmlFileSignUrl) && !is_string($xmlFileSignUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xmlFileSignUrl, true), gettype($xmlFileSignUrl)), __LINE__);
        }
        $this->xmlFileSignUrl = $xmlFileSignUrl;
        return $this;
    }
    /**
     * Get xmlFileSunatUrl value
     * @return string|null
     */
    public function getXmlFileSunatUrl()
    {
        return $this->xmlFileSunatUrl;
    }
    /**
     * Set xmlFileSunatUrl value
     * @param string $xmlFileSunatUrl
     * @return \StructType\DocumentResult
     */
    public function setXmlFileSunatUrl($xmlFileSunatUrl = null)
    {
        // validation for constraint: string
        if (!is_null($xmlFileSunatUrl) && !is_string($xmlFileSunatUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($xmlFileSunatUrl, true), gettype($xmlFileSunatUrl)), __LINE__);
        }
        $this->xmlFileSunatUrl = $xmlFileSunatUrl;
        return $this;
    }
    /**
     * Get tipoDocumentoEmisor value
     * @return string|null
     */
    public function getTipoDocumentoEmisor()
    {
        return $this->tipoDocumentoEmisor;
    }
    /**
     * Set tipoDocumentoEmisor value
     * @param string $tipoDocumentoEmisor
     * @return \StructType\DocumentResult
     */
    public function setTipoDocumentoEmisor($tipoDocumentoEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDocumentoEmisor) && !is_string($tipoDocumentoEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoDocumentoEmisor, true), gettype($tipoDocumentoEmisor)), __LINE__);
        }
        $this->tipoDocumentoEmisor = $tipoDocumentoEmisor;
        return $this;
    }
    /**
     * Get numeroDocumentoEmisor value
     * @return string|null
     */
    public function getNumeroDocumentoEmisor()
    {
        return $this->numeroDocumentoEmisor;
    }
    /**
     * Set numeroDocumentoEmisor value
     * @param string $numeroDocumentoEmisor
     * @return \StructType\DocumentResult
     */
    public function setNumeroDocumentoEmisor($numeroDocumentoEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($numeroDocumentoEmisor) && !is_string($numeroDocumentoEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroDocumentoEmisor, true), gettype($numeroDocumentoEmisor)), __LINE__);
        }
        $this->numeroDocumentoEmisor = $numeroDocumentoEmisor;
        return $this;
    }
    /**
     * Get tipoDocumentoAdquiriente value
     * @return string|null
     */
    public function getTipoDocumentoAdquiriente()
    {
        return $this->tipoDocumentoAdquiriente;
    }
    /**
     * Set tipoDocumentoAdquiriente value
     * @param string $tipoDocumentoAdquiriente
     * @return \StructType\DocumentResult
     */
    public function setTipoDocumentoAdquiriente($tipoDocumentoAdquiriente = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDocumentoAdquiriente) && !is_string($tipoDocumentoAdquiriente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoDocumentoAdquiriente, true), gettype($tipoDocumentoAdquiriente)), __LINE__);
        }
        $this->tipoDocumentoAdquiriente = $tipoDocumentoAdquiriente;
        return $this;
    }
    /**
     * Get numeroDocumentoAdquiriente value
     * @return string|null
     */
    public function getNumeroDocumentoAdquiriente()
    {
        return $this->numeroDocumentoAdquiriente;
    }
    /**
     * Set numeroDocumentoAdquiriente value
     * @param string $numeroDocumentoAdquiriente
     * @return \StructType\DocumentResult
     */
    public function setNumeroDocumentoAdquiriente($numeroDocumentoAdquiriente = null)
    {
        // validation for constraint: string
        if (!is_null($numeroDocumentoAdquiriente) && !is_string($numeroDocumentoAdquiriente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroDocumentoAdquiriente, true), gettype($numeroDocumentoAdquiriente)), __LINE__);
        }
        $this->numeroDocumentoAdquiriente = $numeroDocumentoAdquiriente;
        return $this;
    }
    /**
     * Get razonSocialAdquiriente value
     * @return string|null
     */
    public function getRazonSocialAdquiriente()
    {
        return $this->razonSocialAdquiriente;
    }
    /**
     * Set razonSocialAdquiriente value
     * @param string $razonSocialAdquiriente
     * @return \StructType\DocumentResult
     */
    public function setRazonSocialAdquiriente($razonSocialAdquiriente = null)
    {
        // validation for constraint: string
        if (!is_null($razonSocialAdquiriente) && !is_string($razonSocialAdquiriente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($razonSocialAdquiriente, true), gettype($razonSocialAdquiriente)), __LINE__);
        }
        $this->razonSocialAdquiriente = $razonSocialAdquiriente;
        return $this;
    }
    /**
     * Get razonSocialEmisor value
     * @return string|null
     */
    public function getRazonSocialEmisor()
    {
        return $this->razonSocialEmisor;
    }
    /**
     * Set razonSocialEmisor value
     * @param string $razonSocialEmisor
     * @return \StructType\DocumentResult
     */
    public function setRazonSocialEmisor($razonSocialEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($razonSocialEmisor) && !is_string($razonSocialEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($razonSocialEmisor, true), gettype($razonSocialEmisor)), __LINE__);
        }
        $this->razonSocialEmisor = $razonSocialEmisor;
        return $this;
    }
    /**
     * Get adicionales value
     * @return \StructType\Adicionales|null
     */
    public function getAdicionales()
    {
        return $this->adicionales;
    }
    /**
     * Set adicionales value
     * @param \StructType\Adicionales $adicionales
     * @return \StructType\DocumentResult
     */
    public function setAdicionales(\StructType\Adicionales $adicionales = null)
    {
        $this->adicionales = $adicionales;
        return $this;
    }
    /**
     * Get item value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Item1[]|null
     */
    public function getItem()
    {
        return isset($this->item) ? $this->item : null;
    }
    /**
     * This method is responsible for validating the values passed to the setItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemForArrayConstraintsFromSetItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $documentResultItemItem) {
            // validation for constraint: itemType
            if (!$documentResultItemItem instanceof \StructType\Item1) {
                $invalidValues[] = is_object($documentResultItemItem) ? get_class($documentResultItemItem) : sprintf('%s(%s)', gettype($documentResultItemItem), var_export($documentResultItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The item property can only contain items of type \StructType\Item1, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set item value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Item1[] $item
     * @return \StructType\DocumentResult
     */
    public function setItem(array $item = array())
    {
        // validation for constraint: array
        if ('' !== ($itemArrayErrorMessage = self::validateItemForArrayConstraintsFromSetItem($item))) {
            throw new \InvalidArgumentException($itemArrayErrorMessage, __LINE__);
        }
        if (is_null($item) || (is_array($item) && empty($item))) {
            unset($this->item);
        } else {
            $this->item = $item;
        }
        return $this;
    }
    /**
     * Add item to item value
     * @throws \InvalidArgumentException
     * @param \StructType\Item1 $item
     * @return \StructType\DocumentResult
     */
    public function addToItem(\StructType\Item1 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Item1) {
            throw new \InvalidArgumentException(sprintf('The item property can only contain items of type \StructType\Item1, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->item[] = $item;
        return $this;
    }
}
