<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for eAdjunto StructType
 * @subpackage Structs
 */
class EAdjunto extends AbstractStructBase
{
    /**
     * The attachment
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Attachment
     */
    public $attachment;
    /**
     * The idEmisor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $idEmisor;
    /**
     * The serieCorrelativo
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serieCorrelativo;
    /**
     * The tipoDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tipoDocumento;
    /**
     * Constructor method for eAdjunto
     * @uses EAdjunto::setAttachment()
     * @uses EAdjunto::setIdEmisor()
     * @uses EAdjunto::setSerieCorrelativo()
     * @uses EAdjunto::setTipoDocumento()
     * @param \StructType\Attachment $attachment
     * @param string $idEmisor
     * @param string $serieCorrelativo
     * @param string $tipoDocumento
     */
    public function __construct(\StructType\Attachment $attachment = null, $idEmisor = null, $serieCorrelativo = null, $tipoDocumento = null)
    {
        $this
            ->setAttachment($attachment)
            ->setIdEmisor($idEmisor)
            ->setSerieCorrelativo($serieCorrelativo)
            ->setTipoDocumento($tipoDocumento);
    }
    /**
     * Get attachment value
     * @return \StructType\Attachment|null
     */
    public function getAttachment()
    {
        return $this->attachment;
    }
    /**
     * Set attachment value
     * @param \StructType\Attachment $attachment
     * @return \StructType\EAdjunto
     */
    public function setAttachment(\StructType\Attachment $attachment = null)
    {
        $this->attachment = $attachment;
        return $this;
    }
    /**
     * Get idEmisor value
     * @return string|null
     */
    public function getIdEmisor()
    {
        return $this->idEmisor;
    }
    /**
     * Set idEmisor value
     * @param string $idEmisor
     * @return \StructType\EAdjunto
     */
    public function setIdEmisor($idEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($idEmisor) && !is_string($idEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idEmisor, true), gettype($idEmisor)), __LINE__);
        }
        $this->idEmisor = $idEmisor;
        return $this;
    }
    /**
     * Get serieCorrelativo value
     * @return string|null
     */
    public function getSerieCorrelativo()
    {
        return $this->serieCorrelativo;
    }
    /**
     * Set serieCorrelativo value
     * @param string $serieCorrelativo
     * @return \StructType\EAdjunto
     */
    public function setSerieCorrelativo($serieCorrelativo = null)
    {
        // validation for constraint: string
        if (!is_null($serieCorrelativo) && !is_string($serieCorrelativo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serieCorrelativo, true), gettype($serieCorrelativo)), __LINE__);
        }
        $this->serieCorrelativo = $serieCorrelativo;
        return $this;
    }
    /**
     * Get tipoDocumento value
     * @return string|null
     */
    public function getTipoDocumento()
    {
        return $this->tipoDocumento;
    }
    /**
     * Set tipoDocumento value
     * @param string $tipoDocumento
     * @return \StructType\EAdjunto
     */
    public function setTipoDocumento($tipoDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDocumento) && !is_string($tipoDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoDocumento, true), gettype($tipoDocumento)), __LINE__);
        }
        $this->tipoDocumento = $tipoDocumento;
        return $this;
    }
}
