<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for eConsulta StructType
 * @subpackage Structs
 */
class EConsulta extends AbstractStructBase
{
    /**
     * The estadoDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $estadoDocumento;
    /**
     * The estadoSunat
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $estadoSunat;
    /**
     * The fechaFirmaFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaFirmaFin;
    /**
     * The fechaFirmaInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $fechaFirmaInicio;
    /**
     * The idEmisor
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $idEmisor;
    /**
     * The numeroCorrelativoFin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numeroCorrelativoFin;
    /**
     * The numeroCorrelativoInicio
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numeroCorrelativoInicio;
    /**
     * The numeroDocumentoAdquiriente
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $numeroDocumentoAdquiriente;
    /**
     * The serieGrupoDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $serieGrupoDocumento;
    /**
     * The tipoDocumento
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $tipoDocumento;
    /**
     * Constructor method for eConsulta
     * @uses EConsulta::setEstadoDocumento()
     * @uses EConsulta::setEstadoSunat()
     * @uses EConsulta::setFechaFirmaFin()
     * @uses EConsulta::setFechaFirmaInicio()
     * @uses EConsulta::setIdEmisor()
     * @uses EConsulta::setNumeroCorrelativoFin()
     * @uses EConsulta::setNumeroCorrelativoInicio()
     * @uses EConsulta::setNumeroDocumentoAdquiriente()
     * @uses EConsulta::setSerieGrupoDocumento()
     * @uses EConsulta::setTipoDocumento()
     * @param string $estadoDocumento
     * @param string $estadoSunat
     * @param string $fechaFirmaFin
     * @param string $fechaFirmaInicio
     * @param string $idEmisor
     * @param string $numeroCorrelativoFin
     * @param string $numeroCorrelativoInicio
     * @param string $numeroDocumentoAdquiriente
     * @param string $serieGrupoDocumento
     * @param string $tipoDocumento
     */
    public function __construct($estadoDocumento = null, $estadoSunat = null, $fechaFirmaFin = null, $fechaFirmaInicio = null, $idEmisor = null, $numeroCorrelativoFin = null, $numeroCorrelativoInicio = null, $numeroDocumentoAdquiriente = null, $serieGrupoDocumento = null, $tipoDocumento = null)
    {
        $this
            ->setEstadoDocumento($estadoDocumento)
            ->setEstadoSunat($estadoSunat)
            ->setFechaFirmaFin($fechaFirmaFin)
            ->setFechaFirmaInicio($fechaFirmaInicio)
            ->setIdEmisor($idEmisor)
            ->setNumeroCorrelativoFin($numeroCorrelativoFin)
            ->setNumeroCorrelativoInicio($numeroCorrelativoInicio)
            ->setNumeroDocumentoAdquiriente($numeroDocumentoAdquiriente)
            ->setSerieGrupoDocumento($serieGrupoDocumento)
            ->setTipoDocumento($tipoDocumento);
    }
    /**
     * Get estadoDocumento value
     * @return string|null
     */
    public function getEstadoDocumento()
    {
        return $this->estadoDocumento;
    }
    /**
     * Set estadoDocumento value
     * @param string $estadoDocumento
     * @return \StructType\EConsulta
     */
    public function setEstadoDocumento($estadoDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($estadoDocumento) && !is_string($estadoDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estadoDocumento, true), gettype($estadoDocumento)), __LINE__);
        }
        $this->estadoDocumento = $estadoDocumento;
        return $this;
    }
    /**
     * Get estadoSunat value
     * @return string|null
     */
    public function getEstadoSunat()
    {
        return $this->estadoSunat;
    }
    /**
     * Set estadoSunat value
     * @param string $estadoSunat
     * @return \StructType\EConsulta
     */
    public function setEstadoSunat($estadoSunat = null)
    {
        // validation for constraint: string
        if (!is_null($estadoSunat) && !is_string($estadoSunat)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($estadoSunat, true), gettype($estadoSunat)), __LINE__);
        }
        $this->estadoSunat = $estadoSunat;
        return $this;
    }
    /**
     * Get fechaFirmaFin value
     * @return string|null
     */
    public function getFechaFirmaFin()
    {
        return $this->fechaFirmaFin;
    }
    /**
     * Set fechaFirmaFin value
     * @param string $fechaFirmaFin
     * @return \StructType\EConsulta
     */
    public function setFechaFirmaFin($fechaFirmaFin = null)
    {
        // validation for constraint: string
        if (!is_null($fechaFirmaFin) && !is_string($fechaFirmaFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaFirmaFin, true), gettype($fechaFirmaFin)), __LINE__);
        }
        $this->fechaFirmaFin = $fechaFirmaFin;
        return $this;
    }
    /**
     * Get fechaFirmaInicio value
     * @return string|null
     */
    public function getFechaFirmaInicio()
    {
        return $this->fechaFirmaInicio;
    }
    /**
     * Set fechaFirmaInicio value
     * @param string $fechaFirmaInicio
     * @return \StructType\EConsulta
     */
    public function setFechaFirmaInicio($fechaFirmaInicio = null)
    {
        // validation for constraint: string
        if (!is_null($fechaFirmaInicio) && !is_string($fechaFirmaInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaFirmaInicio, true), gettype($fechaFirmaInicio)), __LINE__);
        }
        $this->fechaFirmaInicio = $fechaFirmaInicio;
        return $this;
    }
    /**
     * Get idEmisor value
     * @return string|null
     */
    public function getIdEmisor()
    {
        return $this->idEmisor;
    }
    /**
     * Set idEmisor value
     * @param string $idEmisor
     * @return \StructType\EConsulta
     */
    public function setIdEmisor($idEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($idEmisor) && !is_string($idEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($idEmisor, true), gettype($idEmisor)), __LINE__);
        }
        $this->idEmisor = $idEmisor;
        return $this;
    }
    /**
     * Get numeroCorrelativoFin value
     * @return string|null
     */
    public function getNumeroCorrelativoFin()
    {
        return $this->numeroCorrelativoFin;
    }
    /**
     * Set numeroCorrelativoFin value
     * @param string $numeroCorrelativoFin
     * @return \StructType\EConsulta
     */
    public function setNumeroCorrelativoFin($numeroCorrelativoFin = null)
    {
        // validation for constraint: string
        if (!is_null($numeroCorrelativoFin) && !is_string($numeroCorrelativoFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroCorrelativoFin, true), gettype($numeroCorrelativoFin)), __LINE__);
        }
        $this->numeroCorrelativoFin = $numeroCorrelativoFin;
        return $this;
    }
    /**
     * Get numeroCorrelativoInicio value
     * @return string|null
     */
    public function getNumeroCorrelativoInicio()
    {
        return $this->numeroCorrelativoInicio;
    }
    /**
     * Set numeroCorrelativoInicio value
     * @param string $numeroCorrelativoInicio
     * @return \StructType\EConsulta
     */
    public function setNumeroCorrelativoInicio($numeroCorrelativoInicio = null)
    {
        // validation for constraint: string
        if (!is_null($numeroCorrelativoInicio) && !is_string($numeroCorrelativoInicio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroCorrelativoInicio, true), gettype($numeroCorrelativoInicio)), __LINE__);
        }
        $this->numeroCorrelativoInicio = $numeroCorrelativoInicio;
        return $this;
    }
    /**
     * Get numeroDocumentoAdquiriente value
     * @return string|null
     */
    public function getNumeroDocumentoAdquiriente()
    {
        return $this->numeroDocumentoAdquiriente;
    }
    /**
     * Set numeroDocumentoAdquiriente value
     * @param string $numeroDocumentoAdquiriente
     * @return \StructType\EConsulta
     */
    public function setNumeroDocumentoAdquiriente($numeroDocumentoAdquiriente = null)
    {
        // validation for constraint: string
        if (!is_null($numeroDocumentoAdquiriente) && !is_string($numeroDocumentoAdquiriente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($numeroDocumentoAdquiriente, true), gettype($numeroDocumentoAdquiriente)), __LINE__);
        }
        $this->numeroDocumentoAdquiriente = $numeroDocumentoAdquiriente;
        return $this;
    }
    /**
     * Get serieGrupoDocumento value
     * @return string|null
     */
    public function getSerieGrupoDocumento()
    {
        return $this->serieGrupoDocumento;
    }
    /**
     * Set serieGrupoDocumento value
     * @param string $serieGrupoDocumento
     * @return \StructType\EConsulta
     */
    public function setSerieGrupoDocumento($serieGrupoDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($serieGrupoDocumento) && !is_string($serieGrupoDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serieGrupoDocumento, true), gettype($serieGrupoDocumento)), __LINE__);
        }
        $this->serieGrupoDocumento = $serieGrupoDocumento;
        return $this;
    }
    /**
     * Get tipoDocumento value
     * @return string|null
     */
    public function getTipoDocumento()
    {
        return $this->tipoDocumento;
    }
    /**
     * Set tipoDocumento value
     * @param string $tipoDocumento
     * @return \StructType\EConsulta
     */
    public function setTipoDocumento($tipoDocumento = null)
    {
        // validation for constraint: string
        if (!is_null($tipoDocumento) && !is_string($tipoDocumento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipoDocumento, true), gettype($tipoDocumento)), __LINE__);
        }
        $this->tipoDocumento = $tipoDocumento;
        return $this;
    }
}
