<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for message StructType
 * @subpackage Structs
 */
class Message extends AbstractStructBase
{
    /**
     * The codeStatus
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codeStatus;
    /**
     * The descriptionStatus
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $descriptionStatus;
    /**
     * The codeDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codeDetail;
    /**
     * The descriptionDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $descriptionDetail;
    /**
     * The listDetail
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $listDetail;
    /**
     * Constructor method for message
     * @uses Message::setCodeStatus()
     * @uses Message::setDescriptionStatus()
     * @uses Message::setCodeDetail()
     * @uses Message::setDescriptionDetail()
     * @uses Message::setListDetail()
     * @param string $codeStatus
     * @param string $descriptionStatus
     * @param string $codeDetail
     * @param string $descriptionDetail
     * @param string $listDetail
     */
    public function __construct($codeStatus = null, $descriptionStatus = null, $codeDetail = null, $descriptionDetail = null, $listDetail = null)
    {
        $this
            ->setCodeStatus($codeStatus)
            ->setDescriptionStatus($descriptionStatus)
            ->setCodeDetail($codeDetail)
            ->setDescriptionDetail($descriptionDetail)
            ->setListDetail($listDetail);
    }
    /**
     * Get codeStatus value
     * @return string|null
     */
    public function getCodeStatus()
    {
        return $this->codeStatus;
    }
    /**
     * Set codeStatus value
     * @param string $codeStatus
     * @return \StructType\Message
     */
    public function setCodeStatus($codeStatus = null)
    {
        // validation for constraint: string
        if (!is_null($codeStatus) && !is_string($codeStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codeStatus, true), gettype($codeStatus)), __LINE__);
        }
        $this->codeStatus = $codeStatus;
        return $this;
    }
    /**
     * Get descriptionStatus value
     * @return string|null
     */
    public function getDescriptionStatus()
    {
        return $this->descriptionStatus;
    }
    /**
     * Set descriptionStatus value
     * @param string $descriptionStatus
     * @return \StructType\Message
     */
    public function setDescriptionStatus($descriptionStatus = null)
    {
        // validation for constraint: string
        if (!is_null($descriptionStatus) && !is_string($descriptionStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptionStatus, true), gettype($descriptionStatus)), __LINE__);
        }
        $this->descriptionStatus = $descriptionStatus;
        return $this;
    }
    /**
     * Get codeDetail value
     * @return string|null
     */
    public function getCodeDetail()
    {
        return $this->codeDetail;
    }
    /**
     * Set codeDetail value
     * @param string $codeDetail
     * @return \StructType\Message
     */
    public function setCodeDetail($codeDetail = null)
    {
        // validation for constraint: string
        if (!is_null($codeDetail) && !is_string($codeDetail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codeDetail, true), gettype($codeDetail)), __LINE__);
        }
        $this->codeDetail = $codeDetail;
        return $this;
    }
    /**
     * Get descriptionDetail value
     * @return string|null
     */
    public function getDescriptionDetail()
    {
        return $this->descriptionDetail;
    }
    /**
     * Set descriptionDetail value
     * @param string $descriptionDetail
     * @return \StructType\Message
     */
    public function setDescriptionDetail($descriptionDetail = null)
    {
        // validation for constraint: string
        if (!is_null($descriptionDetail) && !is_string($descriptionDetail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($descriptionDetail, true), gettype($descriptionDetail)), __LINE__);
        }
        $this->descriptionDetail = $descriptionDetail;
        return $this;
    }
    /**
     * Get listDetail value
     * @return string|null
     */
    public function getListDetail()
    {
        return $this->listDetail;
    }
    /**
     * Set listDetail value
     * @param string $listDetail
     * @return \StructType\Message
     */
    public function setListDetail($listDetail = null)
    {
        // validation for constraint: string
        if (!is_null($listDetail) && !is_string($listDetail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($listDetail, true), gettype($listDetail)), __LINE__);
        }
        $this->listDetail = $listDetail;
        return $this;
    }
}
