<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for receiveFile StructType
 * Meta information extracted from the WSDL
 * - type: tns:receiveFile
 * @subpackage Structs
 */
class ReceiveFile extends AbstractStructBase
{
    /**
     * The zipFile
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $zipFile;
    /**
     * The nameLegado
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $nameLegado;
    /**
     * Constructor method for receiveFile
     * @uses ReceiveFile::setZipFile()
     * @uses ReceiveFile::setNameLegado()
     * @param string $zipFile
     * @param string $nameLegado
     */
    public function __construct($zipFile = null, $nameLegado = null)
    {
        $this
            ->setZipFile($zipFile)
            ->setNameLegado($nameLegado);
    }
    /**
     * Get zipFile value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getZipFile()
    {
        return isset($this->zipFile) ? $this->zipFile : null;
    }
    /**
     * Set zipFile value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $zipFile
     * @return \StructType\ReceiveFile
     */
    public function setZipFile($zipFile = null)
    {
        // validation for constraint: string
        if (!is_null($zipFile) && !is_string($zipFile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($zipFile, true), gettype($zipFile)), __LINE__);
        }
        if (is_null($zipFile) || (is_array($zipFile) && empty($zipFile))) {
            unset($this->zipFile);
        } else {
            $this->zipFile = $zipFile;
        }
        return $this;
    }
    /**
     * Get nameLegado value
     * @return string|null
     */
    public function getNameLegado()
    {
        return $this->nameLegado;
    }
    /**
     * Set nameLegado value
     * @param string $nameLegado
     * @return \StructType\ReceiveFile
     */
    public function setNameLegado($nameLegado = null)
    {
        // validation for constraint: string
        if (!is_null($nameLegado) && !is_string($nameLegado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($nameLegado, true), gettype($nameLegado)), __LINE__);
        }
        $this->nameLegado = $nameLegado;
        return $this;
    }
}
